<?php
/**
 * Ejemplo 9
 * Como crear una orden usando Culqi PHP.
 */

date_default_timezone_set('America/Lima');

try {
  // Usando Composer (o puedes incluir las dependencias manualmente)
  require '../vendor/autoload.php';

  // Configurar tu API Key y autenticación
  $SECRET_KEY = "{SECRET KEY}";
  $culqi = new Culqi\Culqi(array('api_key' => $SECRET_KEY));
  //Datos para encriptar
  $encryption_params = array(
    "rsa_public_key" => "",
    "rsa_id" => ""
  );

  $req_body = array(
    "amount" => 1000,
    "currency_code" => "PEN",
    "description" => 'Venta de prueba',        
    "order_number" => 'pedido-9999',  
    "client_details" => array( 
        "first_name"=> "Brayan", 
        "last_name" => "Cruces",
        "email" => "micorreo@gmail.com", 
        "phone_number" => "51945145222"
     ),
    "expiration_date" => time() + 24*60*60,   // Orden con un dia de validez
    "metadata" => array("dni" => "71702935")
    );

  // Creando Ordern sin encriptar
  $order = $culqi->Orders->create(
      $req_body
  );
  // Respuesta
  echo "<b>Orden sin encriptar payload:</b> "."<br>".json_encode($order)."<br>";;

  // Creando Ordern con encriptación
  $order = $culqi->Orders->create(
    $req_body,
    $encryption_params
);
// Respuesta
echo "<b>Orden con payload encriptado:</b> "."<br>".json_encode($order);

} catch (Exception $e) {
  echo json_encode($e->getMessage());
}
